"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AmauiStyleProvider;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("@amaui/utils");

var _style = require("@amaui/style");

var _AmauiStyleContext = _interopRequireDefault(require("./AmauiStyleContext"));

const _excluded = ["children", "value"];

function makeAmauiStyle(element) {
  const amauiStyle = new _style.AmauiStyle(element); // Add all the plugins

  amauiStyle.plugins.add = [_style.makeClassName, _style.unit, _style.rtl, _style.sort, _style.valueObject];
  return amauiStyle;
}

function AmauiStyleProvider(props) {
  const {
    children,
    value: value_
  } = props,
        other = (0, _objectWithoutProperties2.default)(props, _excluded);

  const ref = _react.default.useRef();

  const [value, setValue] = _react.default.useState(() => {
    if (value_ === undefined || !(value_ instanceof _style.AmauiStyle)) return makeAmauiStyle();
    return value_;
  });

  const setId = _react.default.useState(undefined)[1];

  _react.default.useEffect(() => {
    if (ref.current) {
      value.element = ref.current; // Init

      value.init();
      setId(value.hash);
    }
  }, []);

  const update = (updateValue, override = false) => {
    if (updateValue !== undefined) {
      const valueNew = override ? updateValue : (0, _utils.merge)(updateValue, value);
      setValue(valueNew);
      return valueNew;
    }
  };

  return /*#__PURE__*/_react.default.createElement(_AmauiStyleContext.default.Provider, {
    value: [value, update]
  }, /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    ref: ref
  }, other), children));
}