"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AmauiThemeProvider;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("@amaui/utils");

var _style = require("@amaui/style");

var _AmauiThemeContext = _interopRequireDefault(require("./AmauiThemeContext"));

var _useAmauiTheme = _interopRequireDefault(require("./useAmauiTheme"));

const _excluded = ["children", "value"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function AmauiThemeProvider(props) {
  const {
    children,
    value: valueLocal
  } = props,
        other = (0, _objectWithoutProperties2.default)(props, _excluded);

  const ref = _react.default.useRef();

  const valueParentTheme = ((0, _useAmauiTheme.default)() || [])[0];

  const valueParent = _react.default.useMemo(() => {
    return valueParentTheme || {};
  }, [valueParentTheme === null || valueParentTheme === void 0 ? void 0 : valueParentTheme.hash]);

  const [value] = _react.default.useState(new _style.AmauiTheme((0, _utils.merge)(_objectSpread({}, valueLocal), _objectSpread({}, valueParent), {
    copy: true
  })));

  const setId = _react.default.useState(undefined)[1];

  _react.default.useEffect(() => {
    if (ref.current) {
      value.element = ref.current; // Init

      value.init();
      setId(value.hash);
    }
  }, []);

  _react.default.useEffect(() => {
    // Update
    value.update((0, _utils.merge)(_objectSpread({}, valueLocal), _objectSpread({}, valueParent), {
      copy: true
    }));
    setId(value.hash);
  }, [(0, _utils.hash)(valueLocal), (0, _utils.hash)(valueParent)]);

  const update = updateValue => {
    if (updateValue !== undefined) {
      // Update
      value.update(updateValue);
      setId(value.hash);
      return value;
    }
  };

  return /*#__PURE__*/_react.default.createElement(_AmauiThemeContext.default.Provider, {
    value: [value, update]
  }, /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    ref: ref
  }, other), children));
}