"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = className;

var _react = _interopRequireDefault(require("react"));

var _utils = require("@amaui/utils");

var _style = require("@amaui/style");

var _ = require(".");

// May be TValue or a string  as a string value literal
function className(value_, props = {}, className_ = '', options_ = {}) {
  const [response, setResponse] = _react.default.useState();

  const [values, setValues] = _react.default.useState({
    classes: {},
    classNames: {},
    keyframes: {},
    styles: () => {}
  });

  const [amauiStyle] = (0, _.useAmauiStyle)();
  const [amauiTheme] = (0, _.useAmauiTheme)();
  let value = value_;
  if ((0, _utils.is)('string', value_)) value = {
    a: value_
  };
  let values_ = values; // Init only once
  // it has to be in body of method
  // as for ssr it actually calls the method
  // and it doesn't use hooks on ssr

  if (response === undefined) {
    const options = {
      amaui_style: {
        value: undefined
      },
      amaui_theme: {
        value: undefined
      }
    }; // AmauiStyle

    if (amauiStyle !== undefined) options.amaui_style.value = amauiStyle; // AmauiTheme

    if (amauiTheme !== undefined) options.amaui_theme.value = amauiTheme;
    const response_ = (0, _style.style)(value, (0, _utils.merge)(options, options_, {
      copy: true
    }));
    setResponse(response_); // Update values for ssr as a priorty

    values_ = (0, _style.names)(response_.amaui_style_sheet_manager.names);
    setValues(values_);
  }

  _react.default.useEffect(() => {
    // Add
    const addValues = response.add(props);
    setValues(addValues); // Updates for amauiTheme

    const method = () => {
      if ((0, _utils.is)('function', value)) {
        const valueNew = value(amauiTheme); // Update

        if ((response === null || response === void 0 ? void 0 : response.update) !== undefined) response.update(valueNew);
      }
    };

    if (amauiTheme) amauiTheme.subscriptions.update.subscribe(method); // Clean up

    return () => {
      var _addValues$ids;

      // Unsubscribe
      if (amauiTheme) amauiTheme.subscriptions.update.unsubscribe(method); // Remove

      response.remove((_addValues$ids = addValues.ids) === null || _addValues$ids === void 0 ? void 0 : _addValues$ids.dynamic);
    };
  }, []); // Update props


  _react.default.useEffect(() => {
    if (response !== undefined && values.ids) response.props = {
      ids: values.ids.dynamic,
      props
    };
  }, [(0, _utils.hash)(props)]);

  return values_.class && (0, _style.classNames)([className_, values_.class]) || '';
}