import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
const _excluded = ["children", "value"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React from 'react';
import { hash, merge } from '@amaui/utils';
import { AmauiTheme } from '@amaui/style';
import AmauiThemeContext from './AmauiThemeContext';
import useAmauiTheme from './useAmauiTheme';
export default function AmauiThemeProvider(props) {
  const {
    children,
    value: valueLocal
  } = props,
        other = _objectWithoutProperties(props, _excluded);

  const ref = React.useRef();
  const valueParentTheme = (useAmauiTheme() || [])[0];
  const valueParent = React.useMemo(() => {
    return valueParentTheme || {};
  }, [valueParentTheme === null || valueParentTheme === void 0 ? void 0 : valueParentTheme.hash]);
  const [value] = React.useState(new AmauiTheme(merge(_objectSpread({}, valueLocal), _objectSpread({}, valueParent), {
    copy: true
  })));
  const setId = React.useState(undefined)[1];
  React.useEffect(() => {
    if (ref.current) {
      value.element = ref.current; // Init

      value.init();
      setId(value.hash);
    }
  }, []);
  React.useEffect(() => {
    // Update
    value.update(merge(_objectSpread({}, valueLocal), _objectSpread({}, valueParent), {
      copy: true
    }));
    setId(value.hash);
  }, [hash(valueLocal), hash(valueParent)]);

  const update = updateValue => {
    if (updateValue !== undefined) {
      // Update
      value.update(updateValue);
      setId(value.hash);
      return value;
    }
  };

  return /*#__PURE__*/React.createElement(AmauiThemeContext.Provider, {
    value: [value, update]
  }, /*#__PURE__*/React.createElement("div", _extends({
    ref: ref
  }, other), children));
}