/** @license AmauiStyleReact v1.0.0
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
  "use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  AmauiStyle: true,
  AmauiTheme: true,
  colors: true,
  classNames: true,
  makeClassName: true,
  prefix: true,
  rtl: true,
  sort: true,
  unit: true,
  valueObject: true,
  reset: true,
  r: true,
  pure: true,
  p: true,
  style: true,
  s: true,
  inline: true,
  i: true,
  string: true,
  sr: true,
  className: true,
  c: true,
  cs: true,
  withStyle: true,
  w: true,
  styled: true,
  sy: true
};
Object.defineProperty(exports, "AmauiStyle", {
  enumerable: true,
  get: function () {
    return _style.AmauiStyle;
  }
});
Object.defineProperty(exports, "AmauiTheme", {
  enumerable: true,
  get: function () {
    return _style.AmauiTheme;
  }
});
Object.defineProperty(exports, "c", {
  enumerable: true,
  get: function () {
    return _className.default;
  }
});
Object.defineProperty(exports, "className", {
  enumerable: true,
  get: function () {
    return _className.default;
  }
});
Object.defineProperty(exports, "classNames", {
  enumerable: true,
  get: function () {
    return _style.classNames;
  }
});
Object.defineProperty(exports, "colors", {
  enumerable: true,
  get: function () {
    return _style.colors;
  }
});
Object.defineProperty(exports, "cs", {
  enumerable: true,
  get: function () {
    return _className.default;
  }
});
Object.defineProperty(exports, "i", {
  enumerable: true,
  get: function () {
    return _inline.default;
  }
});
Object.defineProperty(exports, "inline", {
  enumerable: true,
  get: function () {
    return _inline.default;
  }
});
Object.defineProperty(exports, "makeClassName", {
  enumerable: true,
  get: function () {
    return _style.makeClassName;
  }
});
Object.defineProperty(exports, "p", {
  enumerable: true,
  get: function () {
    return _pure.default;
  }
});
Object.defineProperty(exports, "prefix", {
  enumerable: true,
  get: function () {
    return _style.prefix;
  }
});
Object.defineProperty(exports, "pure", {
  enumerable: true,
  get: function () {
    return _pure.default;
  }
});
Object.defineProperty(exports, "r", {
  enumerable: true,
  get: function () {
    return _reset.default;
  }
});
Object.defineProperty(exports, "reset", {
  enumerable: true,
  get: function () {
    return _reset.default;
  }
});
Object.defineProperty(exports, "rtl", {
  enumerable: true,
  get: function () {
    return _style.rtl;
  }
});
Object.defineProperty(exports, "s", {
  enumerable: true,
  get: function () {
    return _style2.default;
  }
});
Object.defineProperty(exports, "sort", {
  enumerable: true,
  get: function () {
    return _style.sort;
  }
});
Object.defineProperty(exports, "sr", {
  enumerable: true,
  get: function () {
    return _string.default;
  }
});
Object.defineProperty(exports, "string", {
  enumerable: true,
  get: function () {
    return _string.default;
  }
});
Object.defineProperty(exports, "style", {
  enumerable: true,
  get: function () {
    return _style2.default;
  }
});
Object.defineProperty(exports, "styled", {
  enumerable: true,
  get: function () {
    return _styled.default;
  }
});
Object.defineProperty(exports, "sy", {
  enumerable: true,
  get: function () {
    return _styled.default;
  }
});
Object.defineProperty(exports, "unit", {
  enumerable: true,
  get: function () {
    return _style.unit;
  }
});
Object.defineProperty(exports, "valueObject", {
  enumerable: true,
  get: function () {
    return _style.valueObject;
  }
});
Object.defineProperty(exports, "w", {
  enumerable: true,
  get: function () {
    return _withStyle.default;
  }
});
Object.defineProperty(exports, "withStyle", {
  enumerable: true,
  get: function () {
    return _withStyle.default;
  }
});

var _style = require("@amaui/style");

var _utils = require("@amaui/style/utils");

Object.keys(_utils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _utils[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _utils[key];
    }
  });
});

var _AmauiStyleProvider = require("./AmauiStyleProvider");

Object.keys(_AmauiStyleProvider).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _AmauiStyleProvider[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _AmauiStyleProvider[key];
    }
  });
});

var _AmauiThemeProvider = require("./AmauiThemeProvider");

Object.keys(_AmauiThemeProvider).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _AmauiThemeProvider[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _AmauiThemeProvider[key];
    }
  });
});

var _reset = _interopRequireDefault(require("./reset"));

var _pure = _interopRequireDefault(require("./pure"));

var _style2 = _interopRequireDefault(require("./style"));

var _inline = _interopRequireDefault(require("./inline"));

var _string = _interopRequireDefault(require("./string"));

var _className = _interopRequireDefault(require("./className"));

var _withStyle = _interopRequireDefault(require("./withStyle"));

var _styled = _interopRequireDefault(require("./styled"));