"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = inline;

var _react = _interopRequireDefault(require("react"));

var _utils = require("@amaui/utils");

var _style = require("@amaui/style");

var _ = require(".");

function inline(value_, props, options_ = {
  response: 'json'
}) {
  const [value, setValue] = _react.default.useState(undefined);

  const [amauiStyle] = (0, _.useAmauiStyle)();
  const [amauiTheme] = (0, _.useAmauiTheme)();

  const update = (updateState = true) => {
    const options = (0, _utils.merge)(options_, {
      amaui_style: {
        value: amauiStyle
      },
      amaui_theme: {
        value: amauiTheme
      }
    }, {
      copy: true
    }); // Options response value

    options.response = 'json';
    const valueNew = (0, _style.inline)(value_, props, options);
    if (updateState) return setValue(valueNew);
    return valueNew;
  }; // Update


  _react.default.useEffect(() => {
    update();
    if (amauiTheme) amauiTheme.subscriptions.update.subscribe(update); // Clean up

    return () => {
      // Unsubscribe
      if (amauiTheme) amauiTheme.subscriptions.update.unsubscribe(update);
    };
  }, []); // Update props


  _react.default.useEffect(() => {
    update();
  }, [(0, _utils.hash)(props)]); // Important for ssr value


  const value__ = value || update(false);
  return value__;
}