"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = string;

var _react = _interopRequireDefault(require("react"));

var _style = require("@amaui/style");

var _ = require(".");

// May be TValue or a string  as a string value literal
function string(value_, ...args) {
  const [response, setResponse] = _react.default.useState();

  const [values, setValues] = _react.default.useState({
    classes: {},
    classNames: {},
    keyframes: {},
    styles: () => {}
  });

  const [amauiStyle] = (0, _.useAmauiStyle)();
  const [amauiTheme] = (0, _.useAmauiTheme)();

  const method = () => value_.reduce((result, item, index) => result += `${item}${args[index] || ''}`, '');

  const value = {
    a: method()
  };
  let values_ = values; // Init only once
  // it has to be in body of method
  // as for ssr it actually calls the method
  // and it doesn't use hooks on ssr

  if (response === undefined) {
    const options = {
      amaui_style: {
        value: undefined
      },
      amaui_theme: {
        value: undefined
      }
    }; // AmauiStyle

    if (amauiStyle !== undefined) options.amaui_style.value = amauiStyle; // AmauiTheme

    if (amauiTheme !== undefined) options.amaui_theme.value = amauiTheme;
    const response_ = (0, _style.style)(value, options);
    setResponse(response_); // Update values for ssr as a priorty

    values_ = (0, _style.names)(response_.amaui_style_sheet_manager.names);
    setValues(values_);
  }

  _react.default.useEffect(() => {
    // Add
    const addValues = response.add();
    setValues(addValues); // Clean up

    return () => {
      var _addValues$ids;

      // Remove
      response.remove((_addValues$ids = addValues.ids) === null || _addValues$ids === void 0 ? void 0 : _addValues$ids.dynamic);
    };
  }, []); // Update
  // if values update based on
  // ui props or useTheme update


  _react.default.useEffect(() => {
    if ((response === null || response === void 0 ? void 0 : response.update) !== undefined) response.update(value);
  }, [value.a]);

  return values_.class || '';
}