"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = style;

var _react = _interopRequireDefault(require("react"));

var _utils = require("@amaui/utils");

var _style = require("@amaui/style");

var _ = require("./");

function style(value, options_ = {}) {
  let response;

  function useStyle(props) {
    const [values, setValues] = _react.default.useState({
      classes: {},
      classNames: {},
      keyframes: {},
      styles: () => {}
    });

    const [amauiStyle] = (0, _.useAmauiStyle)();
    const [amauiTheme] = (0, _.useAmauiTheme)(); // Init only once
    // it has to be in body of method
    // as for ssr it actually calls the method
    // and it doesn't use hooks on ssr

    if (response === undefined) {
      const options = {
        amaui_style: {
          value: undefined
        },
        amaui_theme: {
          value: undefined
        }
      }; // AmauiStyle

      if (amauiStyle !== undefined) options.amaui_style.value = amauiStyle; // AmauiTheme

      if (amauiTheme !== undefined) options.amaui_theme.value = amauiTheme;
      if (response === undefined) response = (0, _style.style)(value, (0, _utils.merge)(options, options_, {
        copy: true
      })); // Update values for ssr as a priorty

      setValues((0, _style.names)(response.amaui_style_sheet_manager.names));
    } // Add


    _react.default.useEffect(() => {
      const addValues = response.add(props);
      setValues(addValues); // Updates for amauiTheme

      const method = () => {
        if ((0, _utils.is)('function', value)) {
          var _response;

          const valueNew = value(amauiTheme); // Update

          if (((_response = response) === null || _response === void 0 ? void 0 : _response.update) !== undefined) response.update(valueNew);
        }
      };

      if (amauiTheme) amauiTheme.subscriptions.update.subscribe(method); // Clean up

      return () => {
        var _addValues$ids;

        // Unsubscribe
        if (amauiTheme) amauiTheme.subscriptions.update.unsubscribe(method); // Remove

        response.remove((_addValues$ids = addValues.ids) === null || _addValues$ids === void 0 ? void 0 : _addValues$ids.dynamic);
      };
    }, []); // Update props


    _react.default.useEffect(() => {
      if (response !== undefined && values.ids) response.props = {
        ids: values.ids.dynamic,
        props
      };
    }, [(0, _utils.hash)(props)]);

    return values;
  }

  return useStyle;
}